/* Lezione quicksort, esericizio 1:
   Ordinare un array A di stringhe, alfabeticamente.
   Le stringhe hanno lunghezza massima N e sono facili
   da leggere con scanf. */
#include <stdio.h>
#include <stdlib.h>

#define MAXSTRLEN 1000

/* Comparatore fra stringhe.
   In input riceve, mascherati da puntatori generici,
   due _puntatori_ agli elementi da ordinare.
   In questo caso, puntatori a stringhe.
   Siccome una stringa e' un vettore a caratteri
   ( char * ), un puntatore a stringhe e' " char ** ".
   Per confrontare le stringhe usiamo strcmp(), funzione
   di libreria apposita.
*/

int comp_stringhe ( const void *param1, const void *param2 )
{
   char **s1 = (char **)param1;
   char **s2 = (char **)param2;

   return strcmp ( *s1, *s2 );
}

/* Un modo alternativo per scriverlo e' il seguente: */
int comp_stringhe2 ( const void *param1, const void *param2 )
{
   /* Qui dereferenziamo immediatamente il puntatore
      subito dopo il cast, in modo da accedere alla stringa
      sottostante. */
   char *s1 = *(char **)param1;
   char *s2 = *(char **)param2;

   return strcmp ( s1, s2 );
}

/* Leggiamo un array di tringhe di lunghezza data. */
char **leggi ( int N ) 
{
   int i;
   char **array = malloc(sizeof(char *)*N );
   for ( i = 0; i < N; i++ ) 
   {
      array[i] = malloc(sizeof(char)*(MAXSTRLEN+1));
      scanf("%s", array[i]); 
   }
   return array;
}

/* Main */
main()
{
   int i, N;
   char **array;

   scanf("%d", &N);
   array = leggi( N );

   qsort( array, N, sizeof(char *), comp_stringhe);

   for ( i = 0; i < N; i++ ) 
     printf("%s\n", array[i] );

   return 0;
}
